Index: release-kits/wirk3/ant-scripts/build.xml
===================================================================
--- release-kits/wirk3/ant-scripts/build.xml	(revision 16631)
+++ release-kits/wirk3/ant-scripts/build.xml	(revision 16748)
@@ -3,14 +3,12 @@
 		.......................................................... 
 		February 2008
-		Windows Release Kit for greenstone3
+		Windows Release Kit for greenstone3 (wirk3)
 		Oran Fry
 		..........................................................
 -->
+
 <project name="wirk3-build" default="wirk3">
 
 	<!-- CONSTANTS -->
-
-	<!-- the size of the resourse chunks to be put in the wrapped installer -->
-	<property name="resources.chunksize" value="8388608"/><!-- 8MiB -->
 
 	<!-- the version numbers of bundled things -->
@@ -18,13 +16,15 @@
 	<property name="bundled.version.ant" value="1.6.5"/>
 
-	<!-- set date !AD HOC, CHANGE SOON -->
-	<property name="current.month" value="Jun"/>
-	<property name="current.year" value="2008"/>
+	<!-- the size of the resourse chunks to be put in the wrapped installer -->
+	<property name="resources.chunksize" value="8388608"/><!-- 8MiB -->
 
 	<!-- for the benefit of the shared scripts, set release-kit home -->
 	<property name="rk.home" value="${wirk3.home}" />
+	<property name="rk.os" value="windows" />
 
 	<!-- IMPORT OTHER ANT SCRIPTS -->
 	<import file="shared-ant-scripts/init.xml"/>
+	<import file="shared-ant-scripts/operations-on-gli.xml"/>
+	<import file="../greenstone3/ant-scripts/rk3-targets.xml"/>
 	<import file="compile.xml"/>
 	<import file="create-distribution.xml"/>
@@ -34,8 +34,8 @@
 	<!-- THE MAIN TARGET -->
 	<target name="wirk3" depends="init">
-		<addressedcall target="compile"/>
-		<addressedcall target="create-distribution"/>
-		<addressedcall target="create-installer"/>
-		<addressedcall target="wrap"/>
+		<antcall target="compile"/>
+		<antcall target="create-distribution"/>
+		<antcall target="create-installer"/>
+		<antcall target="wrap"/>
 	</target>
 
Index: release-kits/wirk3/ant-scripts/compile.xml
===================================================================
--- release-kits/wirk3/ant-scripts/compile.xml	(revision 16631)
+++ release-kits/wirk3/ant-scripts/compile.xml	(revision 16748)
@@ -3,93 +3,72 @@
 
 	<target name="compile">
-		<addressedcall target="checkout-greenstone3" />
-		<addressedcall target="set-version-number-property" />
-		<addressedcall target="dist-prepare-windows" />
-		<addressedcall target="dist-build-windows" />
-		<addressedcall target="prepare-documentation" />
+		<antcall target="checkout-greenstone3" />
+		<antcall target="set-version-number-property" />
+		<ant target="prepare-windows" dir="greenstone3" antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" inheritAll="false">
+			<property name="app.version" value="${version}"/>
+			<property name="branch.path" value="${branch.path}"/>
+			<property name="branch.revision" value="${branch.revision}"/>
+		</ant>
+		<ant target="build-windows" dir="greenstone3" antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" inheritAll="false">
+			<property name="app.version" value="${version}"/>
+			<property name="branch.path" value="${branch.path}"/>
+			<property name="branch.revision" value="${branch.revision}"/>
+		</ant>
+		<antcall target="prepare-documentation" />
 	</target>
 
 	<target name="checkout-greenstone3">
-		<if><bool><istrue value="${execute}"/></bool>
-			<svn>
-				<checkout url="${svn.root}/greenstone3/${branch.path}" destPath="greenstone3" revision="${branch.revision}"/>
-			</svn>
-		</if>
+		<svn>
+			<checkout url="${svn.root}/greenstone3/${branch.path}" destPath="greenstone3" revision="${branch.revision}"/>
+		</svn>
 	</target>
 
 	<target name="set-version-number-property">
-		<if><bool><istrue value="${execute}"/></bool>
-			<rsr file="greenstone3/resources/java/global.properties.in" pattern="(.*)@gsdl3version@(.*)" replacement="$1${version}$2" />
-		</if>
+		<rsr file="greenstone3/resources/java/global.properties.in" pattern="(.*)@gsdl3version@(.*)" replacement="$1${version}$2" />
 	</target>
 
-	<target name="dist-prepare-windows">
-		<if><bool><istrue value="${execute}"/></bool>
-			<ant dir="greenstone3" antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" target="prepare-windows" inheritAll="false">
-				<property name="app.version" value="${version}"/>
-				<property name="branch.path" value="${branch.path}"/>
-				<property name="branch.revision" value="${branch.revision}"/>
-			</ant>
 
-		</if>	
-	</target>
 	<target name="tweak-configure-scripts">
-		<addressedcall target="mgpp-add-static" />
-		<addressedcall target="mg-add-static" />
-		<addressedcall target="gs2buildextra-add-static" />
+		<antcall target="mgpp-add-static" />
+		<antcall target="mg-add-static" />
+		<antcall target="gs2buildextra-add-static" />
 	</target>
 
-	<target name="dist-build-windows">
-		<if><bool><istrue value="${execute}"/></bool>
-			<ant dir="greenstone3" antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" target="build-windows" inheritAll="false">
-				<property name="app.version" value="${version}"/>
-				<property name="branch.path" value="${branch.path}"/>
-				<property name="branch.revision" value="${branch.revision}"/>
-			</ant>
-		</if>
-	</target>
-	
 	<target name="prepare-documentation">
-		<if><bool><istrue value="${execute}"/></bool>
+		<mkdir dir="greenstone3/gsdl-manuals"/>
+		<svn>
+			<checkout url="${svn.root}/documentation/${branch.path}/manuals" destPath="greenstone3/gsdl-manuals/manuals" revision="${branch.revision}"/>
+			<checkout url="${svn.root}/documentation/${branch.path}/shared" destPath="greenstone3/gsdl-manuals/shared" revision="${branch.revision}"/>
+		</svn>
+		<javac srcdir="greenstone3/gsdl-manuals/shared" destdir="greenstone3/gsdl-manuals/shared" debug="on"><include name="*.java"/></javac>
+		<unzip src="greenstone3/gsdl-manuals/shared/fop.zip" dest="greenstone3/gsdl-manuals/shared"/>
 
-			<mkdir dir="greenstone3/gsdl-manuals"/>
-			<svn>
-				<checkout url="${svn.root}/documentation/${branch.path}/manuals" destPath="greenstone3/gsdl-manuals/manuals" revision="${branch.revision}"/>
-				<checkout url="${svn.root}/documentation/${branch.path}/shared" destPath="greenstone3/gsdl-manuals/shared" revision="${branch.revision}"/>
-			</svn>
-			<javac srcdir="greenstone3/gsdl-manuals/shared" destdir="greenstone3/gsdl-manuals/shared" debug="on"><include name="*.java"/></javac>
-			<unzip src="greenstone3/gsdl-manuals/shared/fop.zip" dest="greenstone3/gsdl-manuals/shared"/>
-
-			<echo>Define Classpath</echo>
-			<path id="documentation.compile.classpath">
-				<fileset dir="greenstone3/gsdl-manuals">
-					<include name="**/*.jar"/>
-				</fileset>
-				<pathelement path="greenstone3/gsdl-manuals/shared"/>
-				<pathelement path="greenstone3/gsdl-manuals/manuals"/>
-				<pathelement path="greenstone3/gli/classes"/>
-			</path>
-						
-			<echo>Apply XSLT</echo>
-			<java classname="org.apache.xalan.xslt.Process" classpathref="documentation.compile.classpath" fork="true">
-				<jvmarg value="-DGSDLHOME=${basedir}/greenstone" />
-				<arg value="-IN"/><arg file="greenstone3/gli/help/en/help.xml" />
-				<arg value="-XSL"/><arg file="greenstone3/gsdl-manuals/manuals/processing/gen-gli-help-to-manual-chapter.xsl" />
-				<arg value="-OUT"/><arg file="greenstone3/gsdl-manuals/manuals/xml-source/en/help-en.xml" />
-				
-			</java>
-						
-			<echo>Run generate-pdf.bat</echo>
-			<exec dir="${basedir}\greenstone3/gsdl-manuals/manuals" executable="cmd">
-				<arg value="/C" />
-				<arg file="${basedir}/greenstone3/gsdl-manuals/manuals/generate-pdf.bat" />
-				<arg value="u" />
-				<arg value="en" />
-			</exec>
+		<echo>Define Classpath</echo>
+		<path id="documentation.compile.classpath">
+			<fileset dir="greenstone3/gsdl-manuals">
+				<include name="**/*.jar"/>
+			</fileset>
+			<pathelement path="greenstone3/gsdl-manuals/shared"/>
+			<pathelement path="greenstone3/gsdl-manuals/manuals"/>
+			<pathelement path="greenstone3/gli/classes"/>
+		</path>
+					
+		<echo>Apply XSLT</echo>
+		<java classname="org.apache.xalan.xslt.Process" classpathref="documentation.compile.classpath" fork="true">
+			<jvmarg value="-DGSDLHOME=${basedir}/greenstone" />
+			<arg value="-IN"/><arg file="greenstone3/gli/help/en/help.xml" />
+			<arg value="-XSL"/><arg file="greenstone3/gsdl-manuals/manuals/processing/gen-gli-help-to-manual-chapter.xsl" />
+			<arg value="-OUT"/><arg file="greenstone3/gsdl-manuals/manuals/xml-source/en/help-en.xml" />
 			
-		</if>
+		</java>
+					
+		<echo>Run generate-pdf.bat</echo>
+		<exec dir="${basedir}\greenstone3/gsdl-manuals/manuals" executable="cmd">
+			<arg value="/C" />
+			<arg file="${basedir}/greenstone3/gsdl-manuals/manuals/generate-pdf.bat" />
+			<arg value="u" />
+			<arg value="en" />
+		</exec>
 	</target>
 
-	
-
 </project>
Index: release-kits/wirk3/ant-scripts/create-distribution.xml
===================================================================
--- release-kits/wirk3/ant-scripts/create-distribution.xml	(revision 16631)
+++ release-kits/wirk3/ant-scripts/create-distribution.xml	(revision 16748)
@@ -2,60 +2,44 @@
 <project name="wirk3-create-distribution" default="create-distribution">
 
-
 	<target name="create-distribution">
 		<!-- create distribution -->
-		<addressedcall target="export-greenstone3" />
-		<addressedcall target="dist-set-version-number-property" />
-		<addressedcall target="create-distributions-1" />
-		<addressedcall target="create-distributions-2" />
-		<addressedcall target="create-distributions-3" />
-		<addressedcall target="copy-over-build-xml" />
-		<addressedcall target="insert-user-manual"/>
-		<addressedcall target="insert-compiled-binaries"/>
-		<addressedcall target="rename-build-xml-for-transit"/>
+		<antcall target="export-greenstone3" />
+		<antcall target="gli-set-version-numbers"><param name="glibasedir" value="${basedir}/distribution/greenstone3/gli" />
+
+		<ant target="create-distribution-1" antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" dir="distribution/greenstone3" inheritAll="false">
+			<property name="app.version" value="${version}"/>
+			<property name="branch.path" value="${branch.path}"/>
+			<property name="branch.revision" value="${branch.revision}"/>
+		</ant>
+		<ant target="create-distribution-2" antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" dir="distribution/greenstone3" inheritAll="false">
+			<property name="app.version" value="${version}"/>
+			<property name="branch.path" value="${branch.path}"/>
+			<property name="branch.revision" value="${branch.revision}"/>
+		</ant>
+		<ant target="create-distribution-3" antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" dir="distribution/greenstone3" inheritAll="false">
+			<property name="app.version" value="${version}"/>
+			<property name="branch.path" value="${branch.path}"/>
+			<property name="branch.revision" value="${branch.revision}"/>
+		</ant>
+
+		<antcall target="copy-over-build-xml" />
+		<antcall target="insert-user-manual"/>
+		<antcall target="insert-compiled-binaries"/>
+		<antcall target="rename-build-xml-for-transit"/>
 	</target>
 
 	<target name="export-greenstone3">
-		<if><bool><istrue value="${execute}"/></bool>
-			<mkdir dir="distribution"/>
-			<delete dir="distribution/greenstone3"/>
-			<svn>
-				<export srcurl="${svn.root}/greenstone3/${branch.path}" destPath="distribution/greenstone3" revision="${branch.revision}"/>
-			</svn>
-		</if>
+		<mkdir dir="distribution"/>
+		<delete dir="distribution/greenstone3"/>
+		<svn>
+			<export srcurl="${svn.root}/greenstone3/${branch.path}" destPath="distribution/greenstone3" revision="${branch.revision}"/>
+		</svn>
 	</target>
 
 	<target name="dist-set-version-number-property">
-		<if><bool><istrue value="${execute}"/></bool>
-			<rsr file="distribution/greenstone3/resources/java/global.properties.in" pattern="(.*)@gsdl3version@(.*)" replacement="$1${version}$2" />
-		</if>
-	</target>
-
-	<target name="create-distributions-1">
-		<if><bool><istrue value="${execute}"/></bool>
-			<ant antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" dir="distribution/greenstone3" target="create-distribution-1" inheritAll="false">
-				<property name="app.version" value="${version}"/>
-				<property name="branch.path" value="${branch.path}"/>
-			</ant>
-		</if>
-	</target>
-
-	<target name="create-distributions-2">
-		<if><bool><istrue value="${execute}"/></bool>
-			<ant antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" dir="distribution/greenstone3" target="create-distribution-2" inheritAll="false">
-				<property name="app.version" value="${version}"/>
-				<property name="branch.path" value="${branch.path}"/>
-				<property name="branch.revision" value="${branch.revision}"/>
-			</ant>
-		</if>
-	</target>
-
-	<target name="create-distributions-3">
-		<if><bool><istrue value="${execute}"/></bool>
-			<ant antfile="${wirk3.home}/ant-scripts/operations-on-gs3home.xml" dir="distribution/greenstone3" target="create-distribution-3" inheritall="false">
-				<property name="app.version" value="${version}"/>
-				<property name="branch.path" value="${branch.path}"/>
-			</ant>
-		</if>
+		<rsr
+			file="distribution/greenstone3/resources/java/global.properties.in"
+			pattern="(.*)@gsdl3version@(.*)"
+			replacement="$1${version}$2" />
 	</target>
 
@@ -67,28 +51,22 @@
 
 	<target name="insert-user-manual">
-		<if><bool><istrue value="${execute}"/></bool>
-			<copy file="greenstone3/gsdl-manuals/manuals/build/en/pdf/User_en.pdf" tofile="distribution/greenstone3/docs/manual/gs2_user_en.pdf"/>
-		</if>
+		<copy file="greenstone3/gsdl-manuals/manuals/build/en/pdf/User_en.pdf" tofile="distribution/greenstone3/docs/manual/gs2_user_en.pdf"/>
 	</target>
 
 	<target name="insert-compiled-binaries">
-		<if><bool><istrue value="${execute}"/></bool>
-			
-			<delete dir="distribution/greenstone3/lib/jni"/>
-			<copy todir="distribution/greenstone3/lib/jni"><fileset dir="greenstone3/lib/jni"/></copy>
-			
-			<delete dir="distribution/greenstone3/gs2build/bin/windows"/>
-			<copy todir="distribution/greenstone3/gs2build/bin/windows"><fileset dir="greenstone3/gs2build/bin/windows"/></copy>
-			
-			<delete dir="distribution/greenstone3/gs2build/bin/java"/>
-			<copy todir="distribution/greenstone3/gs2build/bin/java"><fileset dir="greenstone3/gs2build/bin/java"/></copy>
+		<delete dir="distribution/greenstone3/lib/jni"/>
+		<copy todir="distribution/greenstone3/lib/jni"><fileset dir="greenstone3/lib/jni"/></copy>
 		
-		</if>
+		<delete dir="distribution/greenstone3/gs2build/bin/windows"/>
+		<copy todir="distribution/greenstone3/gs2build/bin/windows"><fileset dir="greenstone3/gs2build/bin/windows"/></copy>
+		
+		<delete dir="distribution/greenstone3/gs2build/bin/java"/>
+		<copy todir="distribution/greenstone3/gs2build/bin/java"><fileset dir="greenstone3/gs2build/bin/java"/></copy>
 	</target>
 
 	<target name="rename-build-xml-for-transit">
-		<if><bool><istrue value="${execute}"/></bool>
-			<move file="distribution/greenstone3/build.xml" tofile="distribution/greenstone3/greenstone3-build.xml"/>
-		</if>
+		<move
+			file="distribution/greenstone3/build.xml"
+			tofile="distribution/greenstone3/greenstone3-build.xml" />
 	</target>
 
Index: release-kits/wirk3/ant-scripts/create-installer.xml
===================================================================
--- release-kits/wirk3/ant-scripts/create-installer.xml	(revision 16631)
+++ release-kits/wirk3/ant-scripts/create-installer.xml	(revision 16748)
@@ -3,62 +3,36 @@
 
 	<target name="create-installer">
-		<addressedcall target="setup-for-installer-creation"/>
-		<addressedcall target="compile-installer"/>
+		<antcall target="calculate-component-sizes"/> <!-- from rk3-targets -->
+		<antcall target="copy-installer-files"/>
+		<antcall target="make-installer-files-concrete"/> <!-- from rk3-targets -->
+		<antcall target="compile-installer"/>
 	</target>
 
-	<target name="setup-for-installer-creation">
-		<if><bool><istrue value="${execute}"/></bool>
-			
-			<mkdir dir="${basedir}/installer/resources"/>
-			<copy todir="${basedir}/installer" file="${wirk3.home}/installer/antinstall-config.xml"/>
-			<copy todir="${basedir}/installer" file="${wirk3.home}/installer/build.xml"/>
-			<copy todir="${basedir}/installer/classes">
-				<fileset dir="${wirk3.home}/windows/installer-classes"/>
-				<fileset dir="${wirk3.home}/greenstone3/installer-classes"/>
-				<fileset dir="${wirk3.home}/ant-scripts/tasks/orans" includes="RegexSearchReplace.class" />
-			</copy>
-			
-			<!-- put the concrete values of things in the config -->
-			<rsr file="${basedir}/installer/antinstall-config.xml" pattern="@version@" replacement="${version}"/>
-			<rsr file="${basedir}/installer/build.xml" pattern="@version@" replacement="${version}"/>
-									
-			<!-- put the concrete values of things in the text -->
-			<!-- default -->
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@version@" replacement="${version}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@java.min.version@" replacement="${java.min.version}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@bundled.version.java@" replacement="${bundled.version.windows-java}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@bundled.version.tomcat@" replacement="${bundled.version.tomcat}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@bundled.version.ant@" replacement="${bundled.version.ant}"/>
-			
-			<!-- chinese -->
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@version@" replacement="${version}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@java.min.version@" replacement="${java.min.version}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@bundled.version.java@" replacement="${bundled.version.windows-java}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@bundled.version.tomcat@" replacement="${bundled.version.tomcat}"/>
-			<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@bundled.version.ant@" replacement="${bundled.version.ant}"/>
-			
-			
-		</if>
+	<target name="copy-installer-files">
+		<mkdir dir="${basedir}/installer/resources"/>
+		<copy todir="${basedir}/installer" file="${wirk3.home}/installer/antinstall-config.xml"/>
+		<copy todir="${basedir}/installer" file="${wirk3.home}/installer/build.xml"/>
+		<copy todir="${basedir}/installer/classes">
+			<fileset dir="${wirk3.home}/windows/installer-classes"/>
+			<fileset dir="${wirk3.home}/greenstone3/installer-classes"/>
+			<fileset dir="${wirk3.home}/ant-scripts/tasks/orans" includes="RegexSearchReplace.class" />
+		</copy>
 	</target>
 
 	<target name="compile-installer">
-		<if><bool><istrue value="${execute}"/></bool>
+		<installer file="${basedir}/installer/greenstone-${version}-win32.jar"
+				compress="true"
+				extractType="NonExtractor"
+				installConfig="${basedir}/installer/antinstall-config.xml"
+				buildFile="${basedir}/installer/build.xml"
+				antInstallLib="${wirk3.home}/packages/ant-installer/lib"
+				antLib="${wirk3.home}/packages/ant/lib"
+				validateConfig="true"
+				icons="bluecurve">
+
+			<zipfileset dir="${basedir}/installer/classes" includes="**/*" />
+			<zipfileset dir="${basedir}/distribution/greenstone3" includes="**/*" />
 			
-			<installer file="${basedir}/installer/greenstone-${version}-win32.jar"
-					compress="true"
-					extractType="NonExtractor"
-					installConfig="${basedir}/installer/antinstall-config.xml"
-					buildFile="${basedir}/installer/build.xml"
-					antInstallLib="${wirk3.home}/packages/ant-installer/lib"
-					antLib="${wirk3.home}/packages/ant/lib"
-					validateConfig="true"
-					icons="bluecurve">
-
-				<zipfileset dir="${basedir}/installer/classes" includes="**/*" />
-				<zipfileset dir="${basedir}/distribution/greenstone3" includes="**/*" />
-				
-			</installer>
-			
-		</if>
+		</installer>
 	</target>
 	
Index: release-kits/wirk3/ant-scripts/wrap.xml
===================================================================
--- release-kits/wirk3/ant-scripts/wrap.xml	(revision 16631)
+++ release-kits/wirk3/ant-scripts/wrap.xml	(revision 16748)
@@ -3,137 +3,116 @@
 
 	<target name="wrap">
-		<addressedcall target="copy-files-for-wrapping"/>
-		<addressedcall target="tweak-files-for-wrapping"/>
-		<addressedcall target="compile-resources"/>
-		<addressedcall target="compile-wrapper"/>
-		<addressedcall target="link-wrapper-no-java"/>
-		<addressedcall target="link-wrapper-with-java"/>
+		<antcall target="copy-files-for-wrapping"/>
+		<antcall target="tweak-files-for-wrapping"/>
+		<antcall target="compile-resources"/>
+		<antcall target="compile-wrapper"/>
+		<antcall target="link-wrapper-no-java"/>
+		<antcall target="link-wrapper-with-java"/>
 	</target>
 
 	<target name="copy-files-for-wrapping">
-		<if><bool><istrue value="${execute}"/></bool>
-			
-			<!--create a directory to build the wrapped installer in -->
-			<mkdir dir="${basedir}/wrapped-installer/build"/>
+		<!--create a directory to build the wrapped installer in -->
+		<mkdir dir="${basedir}/wrapped-installer/build"/>
 
-			<!-- copy source files -->
-			<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/windows/wrapper/wrapper.cpp"/>
-			<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/packages/search4j/libsearch4j.cpp"/>
-			<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/packages/search4j/libsearch4j.h"/>
-		
-		</if>
+		<!-- copy source files -->
+		<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/windows/wrapper/wrapper.cpp"/>
+		<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/packages/search4j/libsearch4j.cpp"/>
+		<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/packages/search4j/libsearch4j.h"/>
 	</target>
 	
 	<target name="tweak-files-for-wrapping">
-		<if><bool><istrue value="${execute}"/></bool>
-			
-			<!-- substitute the real java installer filename and min version into various files -->
-			<echo>Substitute concrete values of things into source files</echo>
-			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.min.version@" replacement="${java.min.version}"/>
-			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.installer@" replacement="${windows-java.installer}"/>
-			<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@bundled.version.java@" replacement="${bundled.version.windows-java}"/>
-			
-		</if>
+		<!-- substitute the real java installer filename and min version into various files -->
+		<echo>Substitute concrete values of things into source files</echo>
+		<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.min.version@" replacement="${java.min.version}"/>
+		<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@java.installer@" replacement="${windows-java.installer}"/>
+		<rsr file="${basedir}/wrapped-installer/build/wrapper.cpp" pattern="@bundled.version.java@" replacement="${bundled.version.windows-java}"/>
 	</target>
 
 	<target name="compile-resources">
-		<if><bool><istrue value="${execute}"/></bool>
+		<if>
+			<bool>
+				<not>
+					<uptodate targetfile="${basedir}/wrapped-installer/build/wrapper.RES">
+						<srcfiles dir="${wirk3.home}/greenstone3/icon" includes="icon.ico"/>
+						<srcfiles dir="${wirk3.home}/windows/wrapper" includes="${windows-java.installer}"/>
+						<srcfiles dir="${wirk3.home}/windows/wrapper" includes="*.bmp"/>
+						<srcfiles dir="${wirk3.home}/windows/wrapper" includes="*.rc"/>
+						<srcfiles dir="${wirk3.home}/greenstone3/wrapper" includes="*.bmp"/>
+						<srcfiles dir="${basedir}/installer" includes="greenstone3.jar"/>
+					</uptodate>
+				</not>
+			</bool>
 			
-			<if>
-				<bool>
-					<not>
-						<uptodate targetfile="${basedir}/wrapped-installer/build/wrapper.RES">
-							<srcfiles dir="${wirk3.home}/greenstone3/icon" includes="icon.ico"/>
-							<srcfiles dir="${wirk3.home}/windows/wrapper" includes="${windows-java.installer}"/>
-							<srcfiles dir="${wirk3.home}/windows/wrapper" includes="*.bmp"/>
-							<srcfiles dir="${wirk3.home}/windows/wrapper" includes="*.rc"/>
-							<srcfiles dir="${wirk3.home}/greenstone3/wrapper" includes="*.bmp"/>
-							<srcfiles dir="${basedir}/installer" includes="greenstone3.jar"/>
-						</uptodate>
-					</not>
-				</bool>
-				
-				<echo>Compiling resources</echo>
-				
-				<echo>getting the template resource script</echo>
-				<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/windows/wrapper/wrapper.rc" overwrite="true"/>
-				
-				<echo>copying the small resource files into place</echo>
-				<copy todir="${basedir}/wrapped-installer/build">
-					<fileset dir="${wirk3.home}/windows/wrapper" includes="*.bmp"/>
-					<fileset dir="${wirk3.home}/greenstone3/wrapper" includes="*.bmp"/>
-					<fileset dir="${wirk3.home}/greenstone3/icon" includes="icon.ico"/>
-				</copy>
-				
-				<echo>adding greenstone3.jar to the resource script as chunks</echo>
-				<rsplit
-					resource="${basedir}/installer/greenstone-${version}-win32.jar"
-					outputDir="${basedir}/wrapped-installer/build"
-					resourceScript="${basedir}/wrapped-installer/build/wrapper.rc"
-					resourceName="JAR"
-					resourceType="JAR"
-					chunkSize="${resources.chunksize}"
-					/>
+			<echo>Compiling resources</echo>
 			
-				<echo>resource compiling the resource script</echo>
-				<exec executable="rc" dir="${basedir}/wrapped-installer/build">
-					<arg line="wrapper.rc"/>
-				</exec>
-				
-				<echo>making a copy of the resource script</echo>
-				<copy file="${basedir}/wrapped-installer/build/wrapper.rc" tofile="${basedir}/wrapped-installer/build/wrapper-with-jre.rc"/>
-				
-				<echo>adding ${windows-java.installer} to the copy as chunks</echo>
-				<rsplit
-					resource="${wirk3.home}/windows/wrapper/${windows-java.installer}"
-					outputDir="${basedir}/wrapped-installer/build"					
-					resourceScript="${basedir}/wrapped-installer/build/wrapper-with-jre.rc"
-					resourceName="JAVA"
-					resourceType="EXE"
-					chunkSize="${resources.chunksize}"
-					/>
+			<echo>getting the template resource script</echo>
+			<copy todir="${basedir}/wrapped-installer/build" file="${wirk3.home}/windows/wrapper/wrapper.rc" overwrite="true"/>
+			
+			<echo>copying the small resource files into place</echo>
+			<copy todir="${basedir}/wrapped-installer/build">
+				<fileset dir="${wirk3.home}/windows/wrapper" includes="*.bmp"/>
+				<fileset dir="${wirk3.home}/greenstone3/wrapper" includes="*.bmp"/>
+				<fileset dir="${wirk3.home}/greenstone3/icon" includes="icon.ico"/>
+			</copy>
+			
+			<echo>adding greenstone3.jar to the resource script as chunks</echo>
+			<rsplit
+				resource="${basedir}/installer/greenstone-${version}-win32.jar"
+				outputDir="${basedir}/wrapped-installer/build"
+				resourceScript="${basedir}/wrapped-installer/build/wrapper.rc"
+				resourceName="JAR"
+				resourceType="JAR"
+				chunkSize="${resources.chunksize}"
+				/>
+		
+			<echo>resource compiling the resource script</echo>
+			<exec executable="rc" dir="${basedir}/wrapped-installer/build">
+				<arg line="wrapper.rc"/>
+			</exec>
+			
+			<echo>making a copy of the resource script</echo>
+			<copy file="${basedir}/wrapped-installer/build/wrapper.rc" tofile="${basedir}/wrapped-installer/build/wrapper-with-jre.rc"/>
+			
+			<echo>adding ${windows-java.installer} to the copy as chunks</echo>
+			<rsplit
+				resource="${wirk3.home}/windows/wrapper/${windows-java.installer}"
+				outputDir="${basedir}/wrapped-installer/build"					
+				resourceScript="${basedir}/wrapped-installer/build/wrapper-with-jre.rc"
+				resourceName="JAVA"
+				resourceType="EXE"
+				chunkSize="${resources.chunksize}"
+				/>
 
-				<echo>resource compiling the generated resource script again</echo>
-				<exec executable="rc" dir="${basedir}/wrapped-installer/build">
-					<arg line="wrapper-with-jre.rc"/>
-				</exec>
-				
-				<else>
-					<echo>Resourses are up-to-date, will not compile</echo>
-				</else>
-			</if>
+			<echo>resource compiling the generated resource script again</echo>
+			<exec executable="rc" dir="${basedir}/wrapped-installer/build">
+				<arg line="wrapper-with-jre.rc"/>
+			</exec>
 			
-			
+			<else>
+				<echo>Resourses are up-to-date, will not compile</echo>
+			</else>
 		</if>
 	</target>
 
 	<target name="compile-wrapper">
-		<if><bool><istrue value="${execute}"/></bool>
+		<exec executable="cl" dir="${basedir}/wrapped-installer/build">
+			<arg line="/c -GX /DWINDOWS=yes libsearch4j.cpp /out:libsearch4j.obj"/>
+		</exec>
 
-			<exec executable="cl" dir="${basedir}/wrapped-installer/build">
-				<arg line="/c -GX /DWINDOWS=yes libsearch4j.cpp /out:libsearch4j.obj"/>
-			</exec>
-
-			<exec executable="cl" dir="${basedir}/wrapped-installer/build">
-				<arg line="/c -GX /DWINDOWS=yes wrapper.cpp /out:wrapper.obj"/>
-			</exec>
-			
-		</if>
+		<exec executable="cl" dir="${basedir}/wrapped-installer/build">
+			<arg line="/c -GX /DWINDOWS=yes wrapper.cpp /out:wrapper.obj"/>
+		</exec>
 	</target>
 	
 	<target name="link-wrapper-no-java">
-		<if><bool><istrue value="${execute}"/></bool>
-			<exec executable="link" dir="${basedir}/wrapped-installer/build">
-				<arg line="/OUT:..\greenstone-${version}-win32.exe gdi32.lib advapi32.lib shell32.lib user32.lib libsearch4j.obj wrapper.obj wrapper.res"/>
-			</exec>
-		</if>
+		<exec executable="link" dir="${basedir}/wrapped-installer/build">
+			<arg line="/OUT:..\greenstone-${version}-win32.exe gdi32.lib advapi32.lib shell32.lib user32.lib libsearch4j.obj wrapper.obj wrapper.res"/>
+		</exec>
 	</target>
 
 	<target name="link-wrapper-with-java">
-		<if><bool><istrue value="${execute}"/></bool>
-			<exec executable="link" dir="${basedir}/wrapped-installer/build">
-				<arg line="/OUT:..\greenstone-${version}-win32-with-java.exe gdi32.lib advapi32.lib shell32.lib user32.lib libsearch4j.obj wrapper.obj wrapper-with-jre.res"/>
-			</exec>
-		</if>
+		<exec executable="link" dir="${basedir}/wrapped-installer/build">
+			<arg line="/OUT:..\greenstone-${version}-win32-with-java.exe gdi32.lib advapi32.lib shell32.lib user32.lib libsearch4j.obj wrapper.obj wrapper-with-jre.res"/>
+		</exec>
 	</target>
 