Index: /release-kits/mark3/ant-scripts/build.xml
===================================================================
--- /release-kits/mark3/ant-scripts/build.xml	(revision 16771)
+++ /release-kits/mark3/ant-scripts/build.xml	(revision 16772)
@@ -15,4 +15,7 @@
 	<property name="bundled.version.tomcat" value="5.5.25"/>
 	<property name="bundled.version.ant" value="1.6.5"/>
+
+	<!-- the amount extra space to allocate in the dmgs in (KB) -->
+	<property name="dmg.overhead" value="4096"/>
 
 	<!-- for the benefit of the shared scripts, set release-kit home -->
Index: /release-kits/mark3/ant-scripts/create-installer.xml
===================================================================
--- /release-kits/mark3/ant-scripts/create-installer.xml	(revision 16771)
+++ /release-kits/mark3/ant-scripts/create-installer.xml	(revision 16772)
@@ -3,5 +3,4 @@
 
 	<target name="create-installer">
-		<antcall target="calculate-component-sizes"/> <!-- from rk3-targets -->
 		<antcall target="copy-installer-files"/>
 		<antcall target="make-installer-files-concrete"/> <!-- from rk3-targets -->
Index: /release-kits/mark3/ant-scripts/wrap.xml
===================================================================
--- /release-kits/mark3/ant-scripts/wrap.xml	(revision 16771)
+++ /release-kits/mark3/ant-scripts/wrap.xml	(revision 16772)
@@ -7,5 +7,5 @@
 		<mkdir dir="${basedir}/wrapped-installer"/>
 		<copy todir="${basedir}/wrapped-installer/Greenstone${version}.app"><fileset dir="${mark3.home}/mac/Wrapper.app"/></copy>
-		<copy todir="${basedir}/wrapped-installer/Greenstone${version}.app/Contents/Resources"><fileset dir="${mark2.home}/greenstone3/icon/icon.icns"/></copy>
+		<copy todir="${basedir}/wrapped-installer/Greenstone${version}.app/Contents/Resources" file="${mark3.home}/greenstone3/icon/icon.icns"/>
 		<chmod file="${basedir}/wrapped-installer/Greenstone${version}.app/Contents/MacOS/JavaApplicationStub" perm="ug+x"/>
 
@@ -17,20 +17,21 @@
 		<rsr file="${basedir}/wrapped-installer/Greenstone${version}.app/Contents/Info.plist" pattern="@version@" replacement="${version}"/>
 
-                     <!-- get size of app -->
-                     <exec executable="du" dir="${basedir}/wrapped-installer" outputproperty="app.du"><arg line="-ks Greenstone${version}.app"/></exec>
+		<!-- get size of app -->
+		<exec executable="du" dir="${basedir}/wrapped-installer" outputproperty="app.du"><arg line="-ks Greenstone${version}.app"/></exec>
 		<echo>app.du: ${app.du}</echo>
-                     <exec executable="sed" inputstring="${app.du}" outputproperty="app.size"><arg line="-e 's/^\([0-9]*\).*$/\1/g'"/></exec>
+		<exec executable="sed" inputstring="${app.du}" outputproperty="app.size"><arg line="-e 's/^\([0-9]*\).*$/\1/g'"/></exec>
 		<echo>app.size: ${app.size}</echo>
-		<math result="dmg.size" operand1="${app.size}" operation="+" operand2="2048" datatype="int"/>
+		<math result="dmg.size" operand1="${app.size}" operation="+" operand2="${dmg.overhead}" datatype="int"/>
 		<echo>dmg.size: ${dmg.size}</echo>
 
 		<!-- create disk image -->
-		<exec dir="${basedir}/wrapped-installer" executable="hdiutil"><arg line="create -size ${dmg.size}k -fs HFS+ -volname Greenstone${version} Greenstone${version}.dmg"/></exec>
+		<property name="dmg.name" value="Greenstone-${version}-MacOS-${processor}"/>
+		<exec dir="${basedir}/wrapped-installer" executable="hdiutil"><arg line="create -size ${dmg.size}k -fs HFS+ -volname ${dmg.name} ${dmg.name}.dmg"/></exec>
 		<!-- mount it -->
-		<exec executable="hdiutil" dir="${basedir}/wrapped-installer"><arg line="attach Greenstone${version}.dmg"/></exec>
+		<exec executable="hdiutil" dir="${basedir}/wrapped-installer"><arg line="attach ${dmg.name}.dmg"/></exec>
 		<!-- copy file into it -->
-		<exec executable="cp" dir="${basedir}/wrapped-installer"><arg line="-r Greenstone${version}.app /Volumes/Greenstone${version}"/></exec>
+		<exec executable="cp" dir="${basedir}/wrapped-installer"><arg line="-r Greenstone${version}.app /Volumes/${dmg.name}"/></exec>
 		<!-- unmount it-->
-		<exec executable="hdiutil" dir="${basedir}/wrapped-installer"><arg line="detach /Volumes/Greenstone${version}"/></exec>
+		<exec executable="hdiutil" dir="${basedir}/wrapped-installer"><arg line="detach /Volumes/${dmg.name}"/></exec>
 	</target>
 
Index: /release-kits/mark3/bin/mark3
===================================================================
--- /release-kits/mark3/bin/mark3	(revision 16771)
+++ /release-kits/mark3/bin/mark3	(revision 16772)
@@ -13,2 +13,4 @@
 $toexec
 
+return $?
+