Index: /greenstone3/trunk/web/WEB-INF/classes/interface_classic.properties
===================================================================
--- /greenstone3/trunk/web/WEB-INF/classes/interface_classic.properties	(revision 16785)
+++ /greenstone3/trunk/web/WEB-INF/classes/interface_classic.properties	(revision 16786)
@@ -65,47 +65,47 @@
 help.Creatorlong=<p />You can <i>access publications by author</i> by pressing the <i>authors a-z</i> button.  This brings up a list of books, sorted by author name.  
 help.Subjectshort=access publications by subject
-help.Subjectlong=<p/>You can <i>access publications by subject</i> by pressing the <i>subjects</i> button.  This brings up a list of subjects, represented by bookshelves.
+help.Subjectlong=<p />You can <i>access publications by subject</i> by pressing the <i>subjects</i> button.  This brings up a list of subjects, represented by bookshelves.
 help.Topicshort=access publications by topic
-help.Topiclong=<p>You can <i>access publications by topic</i> by pressing the <i>topic</i> button.  This brings up a list of topics to browse.  
+help.Topiclong=<p />You can <i>access publications by topic</i> by pressing the <i>topic</i> button.  This brings up a list of topics to browse.  
 help.Toshort=access publications by To field
-help.Tolong=<p>You can <i>access publications by To field</i> by pressing the <i>to</i> button.  This brings up a list of addressees.  
+help.Tolong=<p />You can <i>access publications by To field</i> by pressing the <i>to</i> button.  This brings up a list of addressees.  
 help.Fromshort=access publications by From field
-help.Fromlong=<p>You can <i>access publications by From field</i> by pressing the <i>from</i> button.  This brings up a list of senders.  
+help.Fromlong=<p />You can <i>access publications by From field</i> by pressing the <i>from</i> button.  This brings up a list of senders.  
 help.Seriesshort=access publications by series
-help.Serieslong=<p>You can <i>access publications by series</i> by pressing the <i>series</i> button.  This brings up a list of those series which are currently in the collection.  
+help.Serieslong=<p />You can <i>access publications by series</i> by pressing the <i>series</i> button.  This brings up a list of those series which are currently in the collection.  
 help.Dateshort=access publications by date
-help.Datelong=<p>You can <i>access publications by date</i> by pressing the <i>dates</i> button.  This brings up a list of all the issues, sorted chronologically.  
+help.Datelong=<p />You can <i>access publications by date</i> by pressing the <i>dates</i> button.  This brings up a list of all the issues, sorted chronologically.  
 help.Browseshort=browse publications
-help.Browselong=<p>You can <i>browse publications</i> by pressing the <i>browse</i> button.  
+help.Browselong=<p />You can <i>browse publications</i> by pressing the <i>browse</i> button.  
 help.Peopleshort=access publications by people
-help.Peoplelong=<p>You can <i>access publications by people</i> by pressing the <i>people a-z</i> button.  This brings up a list of entries, sorted by surname.  
+help.Peoplelong=<p />You can <i>access publications by people</i> by pressing the <i>people a-z</i> button.  This brings up a list of entries, sorted by surname.  
 help.Languageshort=access publications by language
-help.Languagelong=<p>You can <i>access publications by language</i> by pressing the <i>languages</i> button.  This brings up a list of entries, sorted by language.  
+help.Languagelong=<p />You can <i>access publications by language</i> by pressing the <i>languages</i> button.  This brings up a list of entries, sorted by language.  
 help.Acronymshort=access publications by acronym
-help.Acronymlong=<p>You can <i>access publications by acronym occurrence</i> bypressing the <i>acronyms</i> button.  This brings up a list of the acronyms, and the places that they occur.  
+help.Acronymlong=<p />You can <i>access publications by acronym occurrence</i> bypressing the <i>acronyms</i> button.  This brings up a list of the acronyms, and the places that they occur.  
 help.Phraseshort=browse phrases occurring in publications
-help.Phraselong=<p>You can <i>browse phrases occurring in publications</i> by pressing the <i>phrases</i> button.  This uses the phind phrase browser.  
+help.Phraselong=<p />You can <i>browse phrases occurring in publications</i> by pressing the <i>phrases</i> button.  This uses the phind phrase browser.  
 help.Artistshort=access publications by artist
-help.Artistlong=<p>You can <i>access publications by artist</i> by pressing the <i>artists</i> button.  This brings up a list of entries, sorted by artist name.  
+help.Artistlong=<p />You can <i>access publications by artist</i> by pressing the <i>artists</i> button.  This brings up a list of entries, sorted by artist name.  
 help.Sourceshort=access publications by filename
-help.Sourcelong=<p>You can <i>access publications by filename</i> by pressing the <i>filenames</i> button.  This brings up a list of entries, sorted by original filename.  
+help.Sourcelong=<p />You can <i>access publications by filename</i> by pressing the <i>filenames</i> button.  This brings up a list of entries, sorted by original filename.  
 help.Keywordshort=access publications by keyword
-help.Keywordlong=<p>You can <i>access publications by keyword</i> by pressing the <i>keywords</i> button.  This brings up a list of keywords. 
+help.Keywordlong=<p />You can <i>access publications by keyword</i> by pressing the <i>keywords</i> button.  This brings up a list of keywords. 
 help.Volumeshort=access publications by volume
-help.Volumelong=<p>You can <i>access publications by volume</i> by pressing the <i>volumes</i> button. This brings up a list of volumes. 
+help.Volumelong=<p />You can <i>access publications by volume</i> by pressing the <i>volumes</i> button. This brings up a list of volumes. 
 help.Captionsshort=access publications by caption
-help.Captionslong=<p>You can <i>access publications by caption</i> by pressing the <i>captions</i> button. This brings up a list of captions. 
+help.Captionslong=<p />You can <i>access publications by caption</i> by pressing the <i>captions</i> button. This brings up a list of captions. 
 help.Countriesshort=access publications by country
-help.Countrieslong=<p>You can <i>access publications by country</i> by pressing the <i>countries</i> button. This brings up a list of countries. 
+help.Countrieslong=<p />You can <i>access publications by country</i> by pressing the <i>countries</i> button. This brings up a list of countries. 
 help.short=undefined classification
 help.defaultshort=undefined classification
-help.long=<p>Click on the <i>unknown</i> button to browse publications (listing is sorted by an unknown field).  
-help.defaultlong=<p>Click on the <i>unknown</i> button to browse publications (listing is sorted by an unknown field).  
+help.long=<p />Click on the <i>unknown</i> button to browse publications (listing is sorted by an unknown field).  
+help.defaultlong=<p />Click on the <i>unknown</i> button to browse publications (listing is sorted by an unknown field).  
 help.FileFormatshort=access publications by fileformat
-help.FileFormatlong=<p>You can <i>access publications by fileformat</i> by pressing the <i>fileformat</i> button. This brings up a list of volumes.
+help.FileFormatlong=<p />You can <i>access publications by fileformat</i> by pressing the <i>fileformat</i> button. This brings up a list of volumes.
 help.dls.Titleshort=access publications by title
-help.dls.Titlelong=<p>You can <i>access publications by title</i> by pressing the <i>titles</i> button.  This brings up a list of titles. 
+help.dls.Titlelong=<p />You can <i>access publications by title</i> by pressing the <i>titles</i> button.  This brings up a list of titles. 
 help.dls.Subjectshort=access publications by subject
-help.dls.Subjectlong=<p>You can <i>access publications by subject</i> by pressing the <i>subjects</i> button.  This brings up a list of subjects. 
+help.dls.Subjectlong=<p />You can <i>access publications by subject</i> by pressing the <i>subjects</i> button.  This brings up a list of subjects. 
 
 