Index: /release-kits/wirk2/ant-scripts/build.xml
===================================================================
--- /release-kits/wirk2/ant-scripts/build.xml	(revision 16816)
+++ /release-kits/wirk2/ant-scripts/build.xml	(revision 16817)
@@ -22,4 +22,5 @@
 	<import file="shared-ant-scripts/init.xml"/>
 	<import file="shared-ant-scripts/operations-on-gli.xml"/>
+	<import file="../greenstone2/ant-scripts/rk2-targets.xml"/>
 	<import file="compile.xml"/>
 	<import file="create-distribution.xml"/>
Index: /release-kits/wirk2/ant-scripts/create-installer.xml
===================================================================
--- /release-kits/wirk2/ant-scripts/create-installer.xml	(revision 16816)
+++ /release-kits/wirk2/ant-scripts/create-installer.xml	(revision 16817)
@@ -3,9 +3,11 @@
 
 	<target name="create-installer">
-		<antcall target="setup-for-installer-creation"/>
+		<antcall target="copy-installer-files"/>
+		<antcall target="make-installer-files-concrete"/> <!-- from rk2-targets -->
 		<antcall target="compile-installer"/>
 	</target>
 
-	<target name="setup-for-installer-creation">
+	<target name="copy-installer-files">
+		<echo>Copying installer files</echo>
 		<mkdir dir="${basedir}/installer/classes"/>
 		<copy todir="${basedir}/installer" file="${wirk2.home}/installer/antinstall-config.xml" overwrite="true"/>
@@ -16,23 +18,4 @@
 			<fileset dir="${wirk2.home}/ant-scripts/tasks/orans" includes="RegexSearchReplace.class" />
 		</copy>
-		
-		<!-- put the concrete values of things in the config -->
-		<rsr file="${basedir}/installer/antinstall-config.xml" pattern="@version@" replacement="${version}"/>
-		<rsr file="${basedir}/installer/build.xml" pattern="@version@" replacement="${version}"/>
-								
-		<!-- put the concrete values of things in the text -->
-		<!-- default -->
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@version@" replacement="${version}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@java.min.version@" replacement="${java.min.version}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@bundled.version.java@" replacement="${bundled.version.windows-java}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@bundled.version.tomcat@" replacement="${bundled.version.tomcat}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack.properties" pattern="@bundled.version.ant@" replacement="${bundled.version.ant}"/>
-		
-		<!-- chinese -->
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@version@" replacement="${version}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@java.min.version@" replacement="${java.min.version}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@bundled.version.java@" replacement="${bundled.version.windows-java}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@bundled.version.tomcat@" replacement="${bundled.version.tomcat}"/>
-		<rsr file="${basedir}/installer/classes/resources/LanguagePack_zh_CN.properties" pattern="@bundled.version.ant@" replacement="${bundled.version.ant}"/>
 	</target>
 
Index: /release-kits/wirk2/installer/antinstall-config.xml
===================================================================
--- /release-kits/wirk2/installer/antinstall-config.xml	(revision 16816)
+++ /release-kits/wirk2/installer/antinstall-config.xml	(revision 16817)
@@ -35,7 +35,7 @@
 		<comment name="choose-components"/>
 
-		<target target="install-core-components"			defaultValue="true" displayText="" force="true"/>
-		<target target="install-source-code"				defaultValue="false" displayText="" />
-		<target target="install-start-menu-shortcuts"	defaultValue="true" displayText="" />
+		<target target="install-core-components"			diskRequirement="@component.size.core@"			defaultValue="true"	displayText="" force="true"/>
+		<target target="install-start-menu-shortcuts"	diskRequirement="~10 KB"					 			defaultValue="true"	displayText="" />
+		<target target="install-source-code"				diskRequirement="@component.size.sourcecode@"	defaultValue="false"	displayText="" />
 
 	</page>
Index: /release-kits/wirk2/installer/build.xml
===================================================================
--- /release-kits/wirk2/installer/build.xml	(revision 16816)
+++ /release-kits/wirk2/installer/build.xml	(revision 16817)
@@ -83,11 +83,13 @@
 	<target name="install-source-code" depends="">
 
-	<echo message="Installing Source Code (src)"/>
-		<echo message="Installing Packages (packages)"/>
-		<unzip src="${antinstaller.jar}" dest="${installDir}"><patternset><include name="packages/**/*"/></patternset></unzip>
-		<echo/>
-		
-		<mkdir dir="${installDir}/src"/>
-		<unzip src="${antinstaller.jar}" dest="${installDir}"><patternset><include name="src/**/*"/></patternset></unzip>
+		<echo message="Installing Source Code"/>
+		<unzip src="${antinstaller.jar}" dest="${installDir}">
+			<patternset>
+				<include name="common-src/**/*"/>
+				<include name="runtime-src/**/*"/>
+				<include name="build-src/**/*"/>
+				<include name="packages/**/*"/>
+			</patternset>
+		</unzip>
 		
 	</target>